button = {
  new = function(pratcam,text,callback,x,y,w,h)
    b = {}
    b.pratcam = pratcam
    b.text = text
    b.callback = callback
    b.x,b.y,b.w,b.h = x,y,w,h
    b.draw = button.draw
    b.update = button.update
    return b
  end,
  draw = function(self,high)
    if high then
      love.graphics.setColor(255,255,255)
    else
      love.graphics.setColor(255,127,127)
    end
    love.graphics.rectangle(self.down and "fill" or "line",self.x,self.y,self.w,self.h)
    love.graphics.printf(self.text,self.x,self.y,self.w,"center")
    love.graphics.setColor(255,255,255)
  end,
  update = function(self)
    if not love.mouse.isDown("l") then self.down = nil end
    if love.mouse.getX() > self.x and love.mouse.getX() < self.x + self.w and
      love.mouse.getY() > self.y and love.mouse.getY() < self.y + self.h and
      love.mouse.isDown("l") and not self.down then
      self.down = true
      self:callback()
    end
  end
}

pratcamlib = require('pratcam')

function makedir(classname)
  return "classes_data/"..classname.."/pratcam/"
end

cams = {
  {
    dir = makedir("engie"),
    p = pratcamlib.new(makedir("engie").."still.png",1/24,64,128,512,512),
    buttons = {}
  },
  {
    dir = makedir("medic"),
    p = pratcamlib.new(makedir("medic").."still.png",1/24,64,128,512,512),
    buttons = {}
  },
  {
    dir = makedir("soldier"),
    p = pratcamlib.new(makedir("soldier").."still.png",1/24,64,128,512,512),
    buttons = {}
  },
  {
    dir = makedir("ranger"),
    p = pratcamlib.new(makedir("ranger").."still.png",1/24,64,128,512,512),
    buttons = {}
  }
}

love.window.setMode(
  (64*4+64)*#cams,
  128*4
)

camt = {
  {name = "alt_1",bored=true},
  {name = "alt_2",bored=true},
  {name = "alt_3",bored=true},
  {name = "alt_4",bored=true},
  {name = "alt_5",bored=true},
  {name = "anger"},
  {name = "concern"},
  {name = "death",noloop=true},
  {name = "hit_back"},
  {name = "hit_front"},
  {name = "hit_left"},
  {name = "hit_right"},
  {name = "kill"},
  {name = "laugh"},
  {name = "smile"},
  {name = "special"},
}

for i,e in pairs(cams) do
  for j,t in pairs(camt) do
    table.insert(e.buttons,button.new(e.p,t.name,
      function(self) self.pratcam:nextCam(self.text) end,
      (64*4+64)*(i-1)+64*4,16*(j-1),64,16))
    e.p:addCam(e.dir..t.name..".png",1/24,t.name,t.noloop,t.bored)
  end
end

function love.draw()
  for i,v in pairs(cams) do
    v.p:draw((64*4+64)*(i-1),0,4)
    love.graphics.print("frame: "..v.p.frame.."\n"..
                       "default_count: "..(v.p.default_count or "nil").."\n"..
                       "camc: "..(v.p.camc or "nil").."\n"..
                       "camn: "..(v.p.camn or "nil"),(64*4+64)*(i-1)+16,16)
    for j,w in pairs(v.buttons) do
      w:draw(v.p.metacache[v.p:_lutLookup(w.text)]  )
    end

  end

end

function love.update(dt)
  for i,v in pairs(cams) do
    v.p:update(dt)
    for j,e in pairs(v.buttons) do
      e:update(dt)
    end
  end
end

function love.keypressed(key)
  if key == "r" then
    for i,v in pairs(cams) do
      v.p:resetCam()
    end
  end
end
